diff -uNr src.ORIG/mclibs/herwig/code/hwsspc.F src/mclibs/herwig/code/hwsspc.F
--- src.ORIG/mclibs/herwig/code/hwsspc.F	1996-12-03 23:17:01.000000000 +0900
+++ src/mclibs/herwig/code/hwsspc.F	2005-05-31 02:34:41.000000000 +0900
@@ -7,6 +7,9 @@
 C     REPLACES SPACELIKE PARTONS BY SPECTATORS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUSQR,EMSQ,EMTR,EPAR,XPAR,QSQ
       INTEGER KHEP,IP,JP,IDH,IDP,ISP,IDSPC
       EXTERNAL HWUSQR
@@ -26,14 +29,29 @@
             ELSEIF (IDP.LT.13) THEN
               IDSPC=IDP-6
             ELSE
+#if !defined(CERNLIB_GFORTRAN)
               CALL HWWARN('HWSSPC',100,*999)
+#else
+              call hwwarn('HWSSPC',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
             ENDIF
 C---IDENTIFY SPECTATOR
 C   (1) QUARK CASE
           ELSEIF (IDP.LE.3) THEN
             DO 10 ISP=1,12
+#if !defined(CERNLIB_GFORTRAN)
   10        IF (IDH.EQ.NCLDK(LOCN(IDP,ISP))) GOTO 20
+#else
+               IF (IDH.EQ.NCLDK(LOCN(IDP,ISP))) GOTO 20
+  10        continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWSSPC',101,*999)
+#else
+            call hwwarn('HWSSPC',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
   20        IF (ISP.LE.3) THEN
               IDSPC=ISP+6
             ELSEIF (ISP.LE.9) THEN
@@ -45,8 +63,18 @@
           ELSEIF (IDP.GT.6.AND.IDP.LE.9) THEN
             IDP=IDP-6
             DO 30 ISP=1,12
+#if !defined(CERNLIB_GFORTRAN)
   30        IF (IDH.EQ.NCLDK(LOCN(ISP,IDP))) GOTO 40
+#else
+               IF (IDH.EQ.NCLDK(LOCN(ISP,IDP))) GOTO 40
+  30        continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWSSPC',103,*999)
+#else
+            call hwwarn('HWSSPC',103,iret)
+        if (iret .eq. 1) go to 999
+#endif
             RETURN
   40        IF (ISP.LE.3) THEN
               IDSPC=ISP
@@ -60,10 +88,20 @@
             IF (IDP.EQ.13) THEN
               IDSPC=IDP
             ELSE
+#if !defined(CERNLIB_GFORTRAN)
               CALL HWWARN('HWSSPC',106,*999)
+#else
+              call hwwarn('HWSSPC',106,iret)
+        if (iret .eq. 1) go to 999
+#endif
             ENDIF
           ELSE
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWSSPC',105,*999)
+#else
+            call hwwarn('HWSSPC',105,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
 C---REPLACE PARTON BY SPECTATOR
           IDHW(KHEP)=IDSPC
diff -uNr src.ORIG/mclibs/herwig/code/hwsval.F src/mclibs/herwig/code/hwsval.F
--- src.ORIG/mclibs/herwig/code/hwsval.F	1996-12-03 23:17:02.000000000 +0900
+++ src/mclibs/herwig/code/hwsval.F	2005-05-31 02:34:22.000000000 +0900
@@ -7,6 +7,9 @@
 C     TRUE FOR VALENCE PARTON ID IN INCOMING HADRON INHAD
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER ID,IDHAD
       LOGICAL HWSVAL
       HWSVAL=.FALSE.
@@ -24,6 +27,11 @@
       ELSEIF (IDHAD.EQ.71.OR.IDHAD.EQ.72) THEN
         IF (ID.EQ.13) HWSVAL=.TRUE.
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWSVAL',100,*999)
+#else
+        call hwwarn('HWSVAL',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwualf.F src/mclibs/herwig/code/hwualf.F
--- src.ORIG/mclibs/herwig/code/hwualf.F	1996-12-03 23:17:02.000000000 +0900
+++ src/mclibs/herwig/code/hwualf.F	2005-05-31 02:34:22.000000000 +0900
@@ -12,6 +12,9 @@
 C         .EQ.3  ONE-LOOP WITH 5-FLAVOUR BETA, LAMBDA=QCDL3
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUALF,SCALE,KAFAC,B3,B4,B5,B6,C3,C4,C5,C6,C35,
      & C45,C65,D35,RHO,RAT,RLF,DRH,EPS
       INTEGER IOPT,ITN
@@ -55,10 +58,24 @@
    10   CONTINUE
    20   QCDL3=QCDL5*EXP(0.5*D35)
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
       IF (SCALE.LE.QCDL5) CALL HWWARN('HWUALF',51,*999)
+#else
+      if (SCALE.LE.QCDL5) then
+          call hwwarn('HWUALF',51,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       RHO=2.*LOG(SCALE/QCDL5)
       IF (IOPT.EQ.3) THEN
+#if !defined(CERNLIB_GFORTRAN)
         IF (RHO.LE.D35) CALL HWWARN('HWUALF',52,*999)
+#else
+        if (RHO.LE.D35) then
+          call hwwarn('HWUALF',52,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         HWUALF=1./(B5*(RHO-D35))
         RETURN
       ENDIF
@@ -72,12 +89,26 @@
       ELSE
         RLF=B3*RHO/(1.-C3*RAT)+C35
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
       IF (RLF.LE.ZERO) CALL HWWARN('HWUALF',53,*999)
+#else
+      if (RLF.LE.ZERO) then
+          call hwwarn('HWUALF',53,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       IF (IOPT.EQ.1) THEN
         HWUALF=1./RLF
       ELSE
         HWUALF=B5*(RHO-D35)/RLF
+#if !defined(CERNLIB_GFORTRAN)
         IF (HWUALF.GT.1.) CALL HWWARN('HWUALF',54,*999)
+#else
+        if (HWUALF.GT.1.) then
+          call hwwarn('HWUALF',54,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       ENDIF
       RETURN
  999  HWUALF=ZERO
diff -uNr src.ORIG/mclibs/herwig/code/hwubpr.F src/mclibs/herwig/code/hwubpr.F
--- src.ORIG/mclibs/herwig/code/hwubpr.F	1996-12-03 23:17:02.000000000 +0900
+++ src/mclibs/herwig/code/hwubpr.F	2005-05-31 02:34:41.000000000 +0900
@@ -15,8 +15,14 @@
      &  ' ADA  P-X     P-Y     P-Z   ENERGY    MASS',
      &  '   V-X        V-Y        V-Z        V-C*T')
         DO 20 J=1,NPAR
+#if !defined(CERNLIB_GFORTRAN)
   20    WRITE(6,30) J,RNAME(ABS(IDPAR(J))),TMPAR(J),JDAPAR(1,J),
      &   (JCOPAR(I,J),I=1,4),(PPAR(I,J),I=1,5),(VPAR(I,J),I=1,4)
+#else
+           WRITE(6,30) J,RNAME(ABS(IDPAR(J))),TMPAR(J),JDAPAR(1,J),
+     &   (JCOPAR(I,J),I=1,4),(PPAR(I,J),I=1,5),(VPAR(I,J),I=1,4)
+  20    continue
+#endif
   30    FORMAT(I5,1X,A8,L2,5I4,F7.2,4F8.2,4E11.4)
       ELSE
         WRITE(6,40) INHAD,XFACT
@@ -24,8 +30,14 @@
      &  '    XFACT =',E11.3//'  IPAR ID     TM  DA1 CMO AMO CDA',
      &  ' ADA  P-X     P-Y     P-Z   ENERGY    MASS')
         DO 50 J=1,NPAR
+#if !defined(CERNLIB_GFORTRAN)
   50    WRITE(6,60) J,RNAME(ABS(IDPAR(J))),TMPAR(J),JDAPAR(1,J),
      &   (JCOPAR(I,J),I=1,4),(PPAR(I,J),I=1,5)
+#else
+           WRITE(6,60) J,RNAME(ABS(IDPAR(J))),TMPAR(J),JDAPAR(1,J),
+     &   (JCOPAR(I,J),I=1,4),(PPAR(I,J),I=1,5)
+  50    continue
+#endif
   60    FORMAT(I5,1X,A8,L2,5I4,F7.2,4F8.2)
       ENDIF
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwudks.F src/mclibs/herwig/code/hwudks.F
--- src.ORIG/mclibs/herwig/code/hwudks.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwudks.F	2005-05-31 02:34:41.000000000 +0900
@@ -14,6 +14,9 @@
 C     (N.B. CP violation permits this).
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUPCM,HWUAEM,BRSUM,EPS,SCALE,BRTMP(NMXMOD),FN,X,
      & W,Q,FAC
       INTEGER HWUANT,I,IDKY,LAST,LTMP(NMXMOD),J,L,K,M,N,INDX(NMXMOD),
@@ -31,7 +34,12 @@
 C First zero arrays
       DO 20 I=1,NMXRES
       LSTRT(I)=0
+#if !defined(CERNLIB_GFORTRAN)
   20  NMODES(I)=0
+#else
+         NMODES(I)=0
+  20  continue
+#endif
       DO 30 I=1,NMXDKS
       NPRODS(I)=0
       LNEXT(I)=0.
@@ -72,13 +80,23 @@
      &            IDKPRD(3,L).EQ.IDKPRD(3,J).AND.
      &            IDKPRD(4,L).EQ.IDKPRD(4,J).AND.
      &            IDKPRD(5,L).EQ.IDKPRD(5,J)) GOTO 100
+#if !defined(CERNLIB_GFORTRAN)
   50      L=LNEXT(L)
+#else
+             L=LNEXT(L)
+  50      continue
+#endif
         ELSE
 C Allow for different order in matching
           L=LSTRT(IDKY)
           DO 90 K=1,NMODES(IDKY)
           DO 60 M=1,5
+#if !defined(CERNLIB_GFORTRAN)
   60      MATCH(M)=.FALSE.
+#else
+             MATCH(M)=.FALSE.
+  60      continue
+#endif
           DO 80 M=1,5
           DO 70 N=1,5
           IF (.NOT.MATCH(N).AND.IDKPRD(N,L).EQ.IDKPRD(M,J)) THEN
@@ -89,11 +107,21 @@
   80      CONTINUE
           IF (MATCH(1).AND.MATCH(2).AND.MATCH(3).AND.
      &        MATCH(4).AND.MATCH(5)) GOTO 100
+#if !defined(CERNLIB_GFORTRAN)
   90      L=LNEXT(L)
+#else
+             L=LNEXT(L)
+  90      continue
+#endif
         ENDIF
         CALL HWDCHK(IDKY,J,*120)
         NMODES(IDKY)=NMODES(IDKY)+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NMODES(IDKY).GT.NMXMOD) CALL HWWARN('HWUDKS',100,*999)
+#else
+        IF (NMODES(IDKY).GT.NMXMOD) call hwwarn('HWUDKS',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
         LNEXT(LAST)=J
         BRSUM=BRSUM+BRFRAC(J)
         LTMP(NMODES(IDKY))=J
@@ -125,7 +153,12 @@
           K=LSTRT(IDKY)
           DO 160 J=1,NMODES(IDKY)
           BRFRAC(K)=SCALE*BRFRAC(K)
+#if !defined(CERNLIB_GFORTRAN)
   160     K=LNEXT(K)
+#else
+            K=LNEXT(K)
+  160     continue
+#endif
         ENDIF
       ENDIF
 C Sort branching ratios into descending order and rearrange pointers
@@ -133,7 +166,12 @@
       LSTRT(IDKY)=LTMP(INDX(1))
       LNEXT(LTMP(INDX(1)))=LTMP(INDX(1))
       DO 170 J=2,NMODES(IDKY)
+#if !defined(CERNLIB_GFORTRAN)
   170 LNEXT(LTMP(INDX(J-1)))=LTMP(INDX(J))
+#else
+        LNEXT(LTMP(INDX(J-1)))=LTMP(INDX(J))
+  170 continue
+#endif
       LNEXT(LTMP(INDX(NMODES(IDKY))))=LTMP(INDX(NMODES(IDKY)))
   180 CONTINUE
 C If not a short lived particle with a decay mode then set stable
@@ -150,14 +188,24 @@
 C Set up DKLTM for light quarks
       DO 200 I=1,5
       DKLTM(I)=VMIN2/RMASS(I)**2
+#if !defined(CERNLIB_GFORTRAN)
   200 DKLTM(I+6)=DKLTM(I)
 C gluon
+#else
+        DKLTM(I+6)=DKLTM(I)
+  200 continue
+#endif
       DKLTM(13)=VMIN2/RMASS(13)**2
 C and diquarks
       DO 210 I=109,114
       DKLTM(I)=VMIN2/RMASS(I)**2
+#if !defined(CERNLIB_GFORTRAN)
   210 DKLTM(I+6)=DKLTM(I)
 C Set up DKLTM for weak bosons
+#else
+        DKLTM(I+6)=DKLTM(I)
+  210 continue
+#endif
       DKLTM(198)=EXAG*RMASS(198)/GAMW
       DKLTM(199)=DKLTM(198)
       DKLTM(200)=EXAG*RMASS(200)/GAMZ
@@ -234,8 +282,13 @@
         ELSE
 C First initialize particle matching array
           DO 230 I=1,NMODES(IPART)
+#if !defined(CERNLIB_GFORTRAN)
   230     PMATCH(I)=.FALSE.
 C Loop through antiparticle decay modes
+#else
+            PMATCH(I)=.FALSE.
+  230     continue
+#endif
           LR=LSTRT(IRES)
           DO 290 I=1,NMODES(IRES)
 C Search for conjugate mode allowing for different particle order
@@ -243,7 +296,12 @@
           DO 270 J=1,NMODES(IPART)
           IF (PMATCH(J)) GOTO 270
           DO 240 K=1,5
+#if !defined(CERNLIB_GFORTRAN)
   240     MATCH(K)=.FALSE.
+#else
+            MATCH(K)=.FALSE.
+  240     continue
+#endif
           DO 260 K=1,5
           KPRDLR=HWUANT(IDKPRD(K,LR))
           DO 250 L=1,5
@@ -255,8 +313,13 @@
   260     CONTINUE
           IF (MATCH(1).AND.MATCH(2).AND.MATCH(3).AND.
      &        MATCH(4).AND.MATCH(5)) GOTO 280
+#if !defined(CERNLIB_GFORTRAN)
   270     LP=LNEXT(LP)
 C No match found
+#else
+            LP=LNEXT(LP)
+  270     continue
+#endif
           WRITE(6,350) LR,RNAME(IRES),(RNAME(IDKPRD(J,LR)),J=1,5)
           GOTO 290
 C Match found, check branching ratios and matrix element codes
@@ -267,13 +330,23 @@
           IF (NME(LR).NE.NME(LP))
      &     WRITE(6,370) LR,RNAME(IRES),(RNAME(IDKPRD(J,LR)),J=1,5),
      &                  NME(LR),NME(LP)
+#if !defined(CERNLIB_GFORTRAN)
   290     LR=LNEXT(LR)
 C Check for unmatched modes of particle conjugate to antiparticle
+#else
+            LR=LNEXT(LR)
+  290     continue
+#endif
           LP=LSTRT(IPART)
           DO 300 I=1,NMODES(IPART)
           IF (.NOT.PMATCH(I))
      &     WRITE(6,350) LP,RNAME(IPART),(RNAME(IDKPRD(J,LP)),J=1,5)
+#if !defined(CERNLIB_GFORTRAN)
   300     LP=LNEXT(LP)
+#else
+            LP=LNEXT(LP)
+  300     continue
+#endif
         ENDIF
       ENDIF
   310 CONTINUE
diff -uNr src.ORIG/mclibs/herwig/code/hwudpr.F src/mclibs/herwig/code/hwudpr.F
--- src.ORIG/mclibs/herwig/code/hwudpr.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwudpr.F	2005-05-31 02:34:41.000000000 +0900
@@ -36,7 +36,12 @@
         IF (NMODES(I).GE.2) THEN
           DO 40 J=2,NMODES(I)
           K=LNEXT(K)
+#if !defined(CERNLIB_GFORTRAN)
   40      WRITE(6,50) BRFRAC(K),NME(K),(RNAME(IDKPRD(L,K)),L=1,5)
+#else
+             WRITE(6,50) BRFRAC(K),NME(K),(RNAME(IDKPRD(L,K)),L=1,5)
+  40      continue
+#endif
   50      FORMAT(53X,F5.3,1X,I3,5(1X,A8))
         ENDIF
       ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwueec.F src/mclibs/herwig/code/hwueec.F
--- src.ORIG/mclibs/herwig/code/hwueec.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwueec.F	2005-05-31 02:34:22.000000000 +0900
@@ -8,6 +8,9 @@
 C     in llbar-->qqbar; lepton label IL=1-6: e,nu_e,mu,nu_mu,tau,nu_tau.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION Q2
       INTEGER IL,JL,IQ
       Q2=EMSCA**2
@@ -22,5 +25,12 @@
          TQWT=TQWT+CLQ(1,MAXFL)
       ENDIF
   10  CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
       IF (MAXFL.EQ.0) CALL HWWARN('HWUEEC',100,*999)
+#else
+      if (MAXFL.EQ.0) then
+          call hwwarn('HWUEEC',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwuemv.F src/mclibs/herwig/code/hwuemv.F
--- src.ORIG/mclibs/herwig/code/hwuemv.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwuemv.F	2005-05-31 02:34:41.000000000 +0900
@@ -14,7 +14,12 @@
       LFROM=IFROM
       LTO=ITO
       DO 100 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
  100  IEDT(I)=LTO
+#else
+        IEDT(I)=LTO
+ 100  continue
+#endif
       CALL HWUEDT(-N,IEDT)
       DO 300 I=1,N
         IHEP=LTO+I
diff -uNr src.ORIG/mclibs/herwig/code/hwuepr.F src/mclibs/herwig/code/hwuepr.F
--- src.ORIG/mclibs/herwig/code/hwuepr.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwuepr.F	2005-05-31 02:34:41.000000000 +0900
@@ -37,7 +37,12 @@
      & '   STATUS:',I4,'  ERROR:',I4,'  WEIGHT:',E11.4)
   20  FORMAT(/23X,A28//1X,3A40)
       DO 30 K=1,11
+#if !defined(CERNLIB_GFORTRAN)
   30  FIRST(K)=.TRUE.
+#else
+         FIRST(K)=.TRUE.
+  30  continue
+#endif
       DO 40 J=1,NHEP
       IST=ISTHEP(J)
       IS=IST/10
diff -uNr src.ORIG/mclibs/herwig/code/hwufne.F src/mclibs/herwig/code/hwufne.F
--- src.ORIG/mclibs/herwig/code/hwufne.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwufne.F	2005-05-31 02:34:22.000000000 +0900
@@ -8,6 +8,9 @@
 C     CHECKING FOR ERRORS, AND PRINTING
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       LOGICAL CALLED
       COMMON/HWDBUG/CALLED
       CALLED=.TRUE.
@@ -20,7 +23,14 @@
         ELSE
           NUMERU=NUMERU+1
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (NUMER.GT.MAXER) CALL HWWARN('HWUFNE',300,*999)
+#else
+        if (NUMER.GT.MAXER) then
+          call hwwarn('HWUFNE',300,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         NEVHEP=NEVHEP-1
 C---PRINT FIRST MAXPR EVENTS
       ELSEIF (NEVHEP.LE.MAXPR) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwugau.F src/mclibs/herwig/code/hwugau.F
--- src.ORIG/mclibs/herwig/code/hwugau.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwugau.F	2005-05-31 02:34:22.000000000 +0900
@@ -44,7 +44,12 @@
          BB=C1
          IF (1.+CONST*ABS(C2).NE.1.) GOTO 2
 C---TOO HIGH ACCURACY REQUESTED
+#if !defined(CERNLIB_GFORTRAN)
          CALL HWWARN('HWUGAU',500,*999)
+#else
+         call hwwarn('HWUGAU',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
     5 HWUGAU=HWUGAU+S16
       IF (BB.NE.B) GOTO 1
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwuidt.F src/mclibs/herwig/code/hwuidt.F
--- src.ORIG/mclibs/herwig/code/hwuidt.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwuidt.F	2005-05-31 02:34:22.000000000 +0900
@@ -14,6 +14,9 @@
 C     IOPT= 3 GIVEN NWIG, RETURNS IPDG AND IWIG
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IOPT,IPDG,IWIG,I
       CHARACTER*8 NWIG
       IF (IOPT.EQ.1) THEN
@@ -28,14 +31,24 @@
   20    FORMAT(1X,'Particle not recognised, PDG code: ',I7)
         IWIG=20
         NWIG=RNAME(20)
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWUIDT',101,*999)
+#else
+        call hwwarn('HWUIDT',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ELSEIF (IOPT.EQ.2) THEN
         IF (IWIG.LT.0.OR.IWIG.GT.NRES) THEN
           WRITE(6,30) IWIG
   30      FORMAT(1X,'Particle not recognised, HERWIG code: ',I3)
           IPDG=0
           NWIG=RNAME(20)
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWUIDT',102,*999)
+#else
+          call hwwarn('HWUIDT',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ELSE
           IPDG=IDPDG(IWIG)
           NWIG=RNAME(IWIG)
@@ -53,8 +66,18 @@
   50    FORMAT(1X,'Particle not recognised, HERWIG name: ',A8)
         IWIG=20
         IPDG=0
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWUIDT',103,*999)
+#else
+        call hwwarn('HWUIDT',103,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWUIDT',404,*999)
+#else
+        call hwwarn('HWUIDT',404,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwuinc.F src/mclibs/herwig/code/hwuinc.F
--- src.ORIG/mclibs/herwig/code/hwuinc.F	1996-12-03 23:17:03.000000000 +0900
+++ src/mclibs/herwig/code/hwuinc.F	2005-05-31 02:51:08.000000000 +0900
@@ -7,6 +7,9 @@
 C     COMPUTES CONSTANTS AND LOOKUP TABLES
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWBVMC,HWUALF,HWUPCM,XMIN,XMAX,XPOW,QR,DQKWT,
      & UQKWT,SQKWT,DIQWT,QMAX,PMAX,PTLIM,ETLIM,PGS,PTELM,X,QSCA,UPV,DNV,
      & USEA,DSEA,STR,CHM,BTM,TOP,GLU,VAL(20),CLMXPW,RCLPOW
@@ -101,7 +104,12 @@
         STOP
       ENDIF
       DO 120 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
   120 RMASS(I+6)=RMASS(I)
+#else
+        RMASS(I+6)=RMASS(I)
+  120 continue
+#endif
       RMASS(199)=RMASS(198)
 C---A PRIORI WEIGHTS FOR QUARK AND DIQUARKS
       DQKWT=PWT(1)
@@ -124,7 +132,12 @@
       PMAX=1./PMAX
       QMAX=1./QMAX
       DO 130 I=1,3
+#if !defined(CERNLIB_GFORTRAN)
   130 QWT(I)=PWT(I)*QMAX
+#else
+        QWT(I)=PWT(I)*QMAX
+  130 continue
+#endif
       DO 140 I=1,12
   140 PWT(I)=PWT(I)*PMAX
 C  MASSES OF DIQUARKS (ASSUME BINDING NEGLIGIBLE)
@@ -135,8 +148,13 @@
       RMASS(113)=RMASS(1)+RMASS(3)
       RMASS(114)=RMASS(3)+RMASS(3)
       DO 150 I=109,114
+#if !defined(CERNLIB_GFORTRAN)
   150 RMASS(I+6)=RMASS(I)
 C  MASSES OF TOP HADRONS (ASSUME BINDING NEGLIGIBLE)
+#else
+        RMASS(I+6)=RMASS(I)
+  150 continue
+#endif
       RMASS(232)=RMASS(6)+RMASS(5)
       RMASS(233)=RMASS(6)+RMASS(1)
       RMASS(234)=RMASS(6)+RMASS(2)
@@ -152,8 +170,13 @@
       RMASS(244)=RMASS(6)+RMASS(6)
       RMASS(232)=RMASS(243)
       DO 160 I=233,242
+#if !defined(CERNLIB_GFORTRAN)
   160 RMASS(I+22)=RMASS(I)
 C Set up an array of cluster mass threholds
+#else
+        RMASS(I+22)=RMASS(I)
+  160 continue
+#endif
       CLMXPW=CLMAX**CLPOW
       RCLPOW=ONE/CLPOW
       CALL HWVZRO(144,CTHRPW(1,1))
@@ -161,8 +184,13 @@
       DO 170 J=1,6
       CTHRPW(I ,J  )=(CLMXPW+(RMASS(I    )+RMASS(J+6  ))**CLPOW)**RCLPOW
       CTHRPW(I ,J+6)=(CLMXPW+(RMASS(I    )+RMASS(J+108))**CLPOW)**RCLPOW
+#if !defined(CERNLIB_GFORTRAN)
   170 CTHRPW(I+6,J )=(CLMXPW+(RMASS(I+114)+RMASS(J+6  ))**CLPOW)**RCLPOW
 C Decay length conversion factor GEV2MM hbar.c/e
+#else
+      CTHRPW(I+6,J )=(CLMXPW+(RMASS(I+114)+RMASS(J+6  ))**CLPOW)**RCLPOW
+  170 continue
+#endif
       GEV2MM=1.D-15*SQRT(10.*GEV2NB)
 C Plank's constant/2pi (GeV.s)
       HBAR=GEV2MM/(10.*CSPEED)
@@ -409,7 +437,12 @@
                 WRITE (6,'(10X,A)')'SCHULER-SJOSTRAND PHOTON PDF SET 2M'
               ELSE
                 WRITE (6,'(10X,A)')'UNKNOWN SCHULER-SJOSTRAND PDF SET'
+#if !defined(CERNLIB_GFORTRAN)
                 CALL HWWARN('HWUINC',500,*999)
+#else
+                call hwwarn('HWUINC',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
               ENDIF
               IF (IOP1.EQ.1) THEN
                 WRITE (6,'(10X,A)') 'WITH DIRECT COMPONENT IN DIS'
@@ -472,7 +505,12 @@
       PGS=HWUPCM(RMASS(13),RMASS(I),RMASS(I))
       IF (PGS.GE.0.) NGSPL=I
       IF (PGS.GE.PGSMX) PGSMX=PGS
+#if !defined(CERNLIB_GFORTRAN)
   480 PGSPL(I)=PGS
+#else
+        PGSPL(I)=PGS
+  480 continue
+#endif
       CALL HWVZRO(6,PTINT)
       IF (IPRO.NE.80) THEN
 C---SET UP TABLES OF SUDAKOV FORM FACTORS, GIVING
@@ -484,7 +522,12 @@
         DO 490 J=2,NQEV
         IF (QEV(J,I).GT.QSPAC) GOTO 500
   490   CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
   500   NSPAC(I)=J-1
+#else
+          NSPAC(I)=J-1
+  500   continue
+#endif
       ENDIF
       EVWGT=AVWGT
       ISTAT=1
diff -uNr src.ORIG/mclibs/herwig/code/hwuine.F src/mclibs/herwig/code/hwuine.F
--- src.ORIG/mclibs/herwig/code/hwuine.F	1996-12-03 23:17:04.000000000 +0900
+++ src/mclibs/herwig/code/hwuine.F	2005-05-31 02:34:22.000000000 +0900
@@ -7,6 +7,9 @@
 C     INITIALISES AN EVENT
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRGET,DUMMY
       REAL TL
       LOGICAL CALLED
@@ -17,12 +20,24 @@
         WRITE (6,10)
  10     FORMAT (1X,'A call to the subroutine HWUFNE should be added to',
      &      /,' the main program, immediately after the call to HWMEVT')
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWUINE',500,*999)
+#else
+        call hwwarn('HWUINE',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
       CALLED=.FALSE.
 C---CHECK TIME LEFT
       CALL HWUTIM(TL)
+#if !defined(CERNLIB_GFORTRAN)
       IF (TL.LT.TLOUT) CALL HWWARN('HWUINE',200,*999)
+#else
+      if (TL.LT.TLOUT) then
+          call hwwarn('HWUINE',200,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---UPDATE RANDOM NUMBER SEED
       DUMMY = HWRGET(NRN)
       NEVHEP=NEVHEP+1
diff -uNr src.ORIG/mclibs/herwig/code/hwuli2.F src/mclibs/herwig/code/hwuli2.F
--- src.ORIG/mclibs/herwig/code/hwuli2.F	1996-12-03 23:17:04.000000000 +0900
+++ src/mclibs/herwig/code/hwuli2.F	2005-05-31 02:52:51.000000000 +0900
@@ -7,6 +7,9 @@
 C     Complex dilogarithm function, Li_2 (Spence function)
 C-----------------------------------------------------------------------
       IMPLICIT NONE
+#if defined(CERNLIB_GFORTRAN)
+      double complex imag
+#endif
       DOUBLE COMPLEX HWULI2,PROD,Y,Y2,X,Z
       DOUBLE PRECISION XR,XI,R2,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,ZETA2,
      & ZERO,ONE,HALF
diff -uNr src.ORIG/mclibs/herwig/code/hwures.F src/mclibs/herwig/code/hwures.F
--- src.ORIG/mclibs/herwig/code/hwures.F	1996-12-03 23:17:05.000000000 +0900
+++ src/mclibs/herwig/code/hwures.F	2005-05-31 02:34:41.000000000 +0900
@@ -11,6 +11,9 @@
 C     Sets CLDKWT(K) =(2J+1) spin weight normalizing largest value to 1.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER NMXTMP
       PARAMETER (NMXTMP=20)
       DOUBLE PRECISION HWUPCM,HWUAEM,EPS,WTMX,REMMN,RWTMX,WTMP,
@@ -99,7 +102,14 @@
       DO 90 J=21,NRES
       IF (VTOCDK(J).OR.IFLAV(J).NE.MAPF(I)) GOTO 90
       NCDKS=NCDKS+1
+#if !defined(CERNLIB_GFORTRAN)
       IF (NCDKS.GT.NMXCDK) CALL HWWARN('HWURES',101,*999)
+#else
+      if (NCDKS.GT.NMXCDK) then
+          call hwwarn('HWURES',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       NCLDK(NCDKS)=J
       CLDKWT(NCDKS)=TWO*RSPIN(J)+ONE
       IF (CLDKWT(NCDKS).GT.WTMX) WTMX=CLDKWT(NCDKS)
@@ -117,8 +127,13 @@
 C Set scaled spin weights
       RWTMX=1./WTMX
       DO 110 J=LTMP,NCDKS
+#if !defined(CERNLIB_GFORTRAN)
   110 CLDKWT(J)=CLDKWT(J)*RWTMX
 C Swap order if lightest hadron of given flavour not first
+#else
+        CLDKWT(J)=CLDKWT(J)*RWTMX
+  110 continue
+#endif
       IF (IMN.NE.LTMP) THEN
         ITMP=NCLDK(LTMP)
         WTMP=CLDKWT(LTMP)
@@ -180,7 +195,14 @@
       ENDIF
       IF (WT.GT.EPS) THEN
         NCDKS=NCDKS+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NCDKS.GT.NMXCDK) CALL HWWARN('HWURES',102,*999)
+#else
+        if (NCDKS.GT.NMXCDK) then
+          call hwwarn('HWURES',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         NCLDK(NCDKS)=J
         CLDKWT(NCDKS)=WT*(TWO*RSPIN(J)+ONE)
         IF (CLDKWT(NCDKS).GT.WTMX) WTMX=CLDKWT(NCDKS)
@@ -191,7 +213,14 @@
       ENDIF
       IF (ONE-WT.GT.EPS) THEN
         NTMP=NTMP+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NTMP.GT.NMXTMP) CALL HWWARN('HWURES',103,*999)
+#else
+        if (NTMP.GT.NMXTMP) then
+          call hwwarn('HWURES',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         NCDTMP(NTMP)=J
         CDWTMP(NTMP)=(ONE-WT)*(TWO*RSPIN(J)+ONE)
         IF (CDWTMP(NTMP).GT.WTMX2) WTMX2=CDWTMP(NTMP)
@@ -208,8 +237,13 @@
 C Normalize scaled spin weights
       RWTMX=1./WTMX
       DO 150 I=LTMP,NCDKS
+#if !defined(CERNLIB_GFORTRAN)
   150 CLDKWT(I)=CLDKWT(I)*RWTMX
 C Swap order if lightest hadron of flavour 11 not first
+#else
+        CLDKWT(I)=CLDKWT(I)*RWTMX
+  150 continue
+#endif
       IF (IMN.NE.LTMP) THEN
         ITMP=NCLDK(LTMP)
         WTMP=CLDKWT(LTMP)
@@ -222,14 +256,26 @@
         WRITE(6,100) 33
         CALL HWWARN('HWURES',53,*180)
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
       IF (NCDKS+NTMP.GT.NMXCDK) CALL HWWARN('HWURES',104,*999)
+#else
+      if (NCDKS+NTMP.GT.NMXCDK) then
+          call hwwarn('HWURES',104,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C Store hadrons for |ssbar> channel and normalize their weights
       RWTMX=1./WTMX2
       DO 170 I=1,NTMP
       J=NCDKS+I
       NCLDK(J)=NCDTMP(I)
+#if !defined(CERNLIB_GFORTRAN)
   170 CLDKWT(J)=CDWTMP(I)*RWTMX
 C Swap order if lightest hadron of flavour 33 not first
+#else
+        CLDKWT(J)=CDWTMP(I)*RWTMX
+  170 continue
+#endif
       IF (IMN2.NE.1) THEN
         ITMP=NCLDK(NCDKS+1)
         WTMP=CLDKWT(NCDKS+1)
diff -uNr src.ORIG/mclibs/herwig/code/hwusor.F src/mclibs/herwig/code/hwusor.F
--- src.ORIG/mclibs/herwig/code/hwusor.F	1996-12-03 23:17:05.000000000 +0900
+++ src/mclibs/herwig/code/hwusor.F	2005-05-31 02:34:41.000000000 +0900
@@ -10,7 +10,14 @@
 C-----------------------------------------------------------------------
       DOUBLE PRECISION A(N),B(500)
       INTEGER N,I,J,IOPT,K(N),IL(500),IR(500)
+#if !defined(CERNLIB_GFORTRAN)
       IF (N.GT.500) CALL HWWARN('HWUSOR',100,*999)
+#else
+      if (N.GT.500) then
+          call hwwarn('HWUSOR',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       IL(1)=0
       IR(1)=0
       DO 10 I=2,N
@@ -45,5 +52,10 @@
       GOTO 9
   30  IF(IOPT.EQ.2) RETURN
       DO 31 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
   31  A(I)=B(I)
+#else
+         A(I)=B(I)
+  31  continue
+#endif
  999  END
diff -uNr src.ORIG/mclibs/herwig/code/hwusta.F src/mclibs/herwig/code/hwusta.F
--- src.ORIG/mclibs/herwig/code/hwusta.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwusta.F	2005-05-31 02:34:22.000000000 +0900
@@ -7,10 +7,20 @@
 C     MAKES PARTICLE TYPE 'NAME' STABLE
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IPDG,IWIG
       CHARACTER*8 NAME
       CALL HWUIDT(3,IPDG,IWIG,NAME)
+#if !defined(CERNLIB_GFORTRAN)
       IF (IWIG.EQ.20) CALL HWWARN('HWUSTA',500,*999)
+#else
+      if (IWIG.EQ.20) then
+          call hwwarn('HWUSTA',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       RSTAB(IWIG)=.TRUE.
       WRITE (6,10) IWIG,NAME
    10 FORMAT(/10X,'PARTICLE TYPE',I4,'=',A8,' SET STABLE')
diff -uNr src.ORIG/mclibs/herwig/code/hwvdif.F src/mclibs/herwig/code/hwvdif.F
--- src.ORIG/mclibs/herwig/code/hwvdif.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvdif.F	2005-05-31 02:34:41.000000000 +0900
@@ -9,5 +9,10 @@
       DOUBLE PRECISION P(N),Q(N),R(N)
       INTEGER N,I
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 R(I)=P(I)-Q(I)
+#else
+         R(I)=P(I)-Q(I)
+   10 continue
+#endif
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwvdot.F src/mclibs/herwig/code/hwvdot.F
--- src.ORIG/mclibs/herwig/code/hwvdot.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvdot.F	2005-05-31 02:34:41.000000000 +0900
@@ -10,6 +10,11 @@
       INTEGER N,I
       PQ=0.
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 PQ=PQ+P(I)*Q(I)
+#else
+         PQ=PQ+P(I)*Q(I)
+   10 continue
+#endif
       HWVDOT=PQ
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwvequ.F src/mclibs/herwig/code/hwvequ.F
--- src.ORIG/mclibs/herwig/code/hwvequ.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvequ.F	2005-05-31 02:34:41.000000000 +0900
@@ -9,5 +9,10 @@
       DOUBLE PRECISION P(N),Q(N)
       INTEGER N,I
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 Q(I)=P(I)
+#else
+         Q(I)=P(I)
+   10 continue
+#endif
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwvsca.F src/mclibs/herwig/code/hwvsca.F
--- src.ORIG/mclibs/herwig/code/hwvsca.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvsca.F	2005-05-31 02:34:41.000000000 +0900
@@ -9,5 +9,10 @@
       DOUBLE PRECISION C,P(N),Q(N)
       INTEGER N,I
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 Q(I)=C*P(I)
+#else
+         Q(I)=C*P(I)
+   10 continue
+#endif
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwvsum.F src/mclibs/herwig/code/hwvsum.F
--- src.ORIG/mclibs/herwig/code/hwvsum.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvsum.F	2005-05-31 02:34:41.000000000 +0900
@@ -9,5 +9,10 @@
       DOUBLE PRECISION P(N),Q(N),R(N)
       INTEGER N,I
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 R(I)=P(I)+Q(I)
+#else
+         R(I)=P(I)+Q(I)
+   10 continue
+#endif
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwvzro.F src/mclibs/herwig/code/hwvzro.F
--- src.ORIG/mclibs/herwig/code/hwvzro.F	1996-12-03 23:17:06.000000000 +0900
+++ src/mclibs/herwig/code/hwvzro.F	2005-05-31 02:34:41.000000000 +0900
@@ -9,5 +9,10 @@
       DOUBLE PRECISION P(N)
       INTEGER N,I
       DO 10 I=1,N
+#if !defined(CERNLIB_GFORTRAN)
    10 P(I)=0.
+#else
+         P(I)=0.
+   10 continue
+#endif
       END
